
/*!\file
 * \brief         .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "mem_test.h"
uint8_t* reg = (uint8_t*)0x20004;
uint32_t err_numbers[31];

uint32_t a;

unsigned int Memtest_Addr_inner(unsigned int addr_start,unsigned int addr_stop, unsigned int mask)
{
       unsigned int addr;
       unsigned int errors = 0;   
       volatile  uint32_t i=0;
     //  *reg = mask;   ///<  

           for (addr = addr_start; addr < addr_stop; addr += 4)
           {
            {
              
              *(unsigned int*)addr = mask;
     
            }      

              i+=1;
           }    ///<  Pagei
           
           
uint32_t j=0;
       for (addr = addr_start; addr < addr_stop; addr += 4)
        {
          a = *(uint32_t*)addr;
           
                 
                if (a!=mask)//(j*mask+10)*0x12345678)//|0xFFFFF000))
                {
                   PRINT("Address (0x%x) read: 0x%x wr:0x%x",addr,*(unsigned int*)addr,mask); 
                 /*   if (a!=0xDFFFFFFF)
                    {
                        int a =10;
                    }*/
                    
                        errors++;
                    //    *(uint32_t*)0x20001000 = 0x12345678;
                }
                j+=1;
          
        }       ///<  Page0    Pagei
       
       if (errors>0)
       {
          err_numbers[1] = 1;
       }
       else
       {
                   err_numbers[1] = 0;
       }
        return errors;
}

unsigned int Memtest_Addr( unsigned int mask)
{
       unsigned int addr;
       unsigned int errors = 0;   
       volatile  uint32_t i=0;
       *reg = mask;   ///<  

           for (addr = 0x10000; addr < 0x20000; addr += 4)
           {
            {
              
              *(unsigned int*)addr = (i)*0x12345678;
     
            }      

              i+=1;
           }    ///<  Pagei
           
           
uint32_t j=0;
       for (addr = 0x10000; addr < 0x20000; addr += 4)
        {
          a = *(uint32_t*)addr;
                   if (mask>27)
                  {
                        
                    for (int k = 0; k < 100; k += 1);        
                  }
           
               //   int val = (j);
                if ((a!=(j*0x12345678))&&(addr!=0x4))//(j*mask+10)*0x12345678)//|0xFFFFF000))
                {
                  // PRINT("Address (0x%x) read: 0x%x wr:0x%x",addr,*(unsigned int*)addr,val); 
                  

                        errors++;
                }
                j+=1;
          
        }       ///<  Page0    Pagei
       
       if (errors>0)
       {
          err_numbers[mask] = mask;
       }
       else
       {
                   err_numbers[mask] = 0;
       }
        return errors;
}
      
//============================================================= 
uint32_t Test_inner(uint32_t* err,
              uint32_t* err2,
              uint32_t* err3,
              uint32_t* err4,
              uint32_t* err5,
              uint32_t* err6,
              uint32_t* err7,Answer* common_out )
{
 
            PRINT(" IN_Memmory");
            common_out->ErrorFlag=0;
            *err+= Memtest_Addr_inner(0x20000000,0x2001ffff,0xFFFFFFFF);  //  0xFFFFFFFF
            *err+= Memtest_Addr_inner(0x20000000,0x2001ffff,0);  
            
            *err2+= Memtest_Addr_inner(0x60000000,0x6000ffff,0xFFFFFFFF);  //  0xFFFFFFFF
            *err2+= Memtest_Addr_inner(0x60000000,0x6000ffff,0);  
            
            *err3+= Memtest_Addr_inner(0x60100000,0x6010ffff,0x1F1F1F1F);  //     1,  ECC ( 20 )
            *err3+= Memtest_Addr_inner(0x60100000,0x6010ffff,0);               
            
            *err4+= Memtest_Addr_inner(0x61000000,0x61003fff,0xFFFFFFFF);  //     way1 
            *err4+= Memtest_Addr_inner(0x61000000,0x61003fff,0);  
            
            *err5+= Memtest_Addr_inner(0x61100000,0x61103fff,0x001FFFFF);  //     way1   crc ( 18 )
            *err5+= Memtest_Addr_inner(0x61100000,0x61103fff,0); 
            
            *err6+= Memtest_Addr_inner(0x62000000,0x6200ffff,0xFFFFFFFF);  //     2, 
            *err6+= Memtest_Addr_inner(0x62000000,0x6200ffff,0); 

            *err7+= Memtest_Addr_inner(0x62100000,0x6210ffff,0x1F1F1F1F);  //     2,  ECC ( 20 )
            *err7+= Memtest_Addr_inner(0x62100000,0x6210ffff,0); 
            
            if ((*err>0)|(*err2>2)|(*err3>3)|(*err4>4)|(*err5>5)|(*err6>6)|(*err7>7))
            {
                common_out->ErrorFlag=1;
            }
            
            return 0;
}

void TestPage(Answer* common_out )
{
        PRINT(" counter");
        DBG_TX_Flush();                                                             //     UART
  for (int i=0;i<=31;i++)
  {
        PRINT("  %d",i);
        DBG_TX_Flush();                                                             //     UART
     
        Memtest_Addr(i);  ///  
        
        
     
  }
  for (int  i=0;i<=31;i++)
  {
    PRINT("err_numbers:%d = %d",i,err_numbers[i]);
    common_out->ErrorFlag+=err_numbers[i];
  }
}

char dbg_buffer[256];                                                           //   
const uint32_t sys_freq = 80000000;                                             //  

/**
 * @brief   
 *   
 * @retval None
 */
void Mem_Test()
{
    PRINT(" ");
    DBG_TX_Flush();                                                             //     UART
    
    //   TestMEM   
    TEST_MEM TestMEM = {0};                                                     
    
    //       !
    TestMEM.block.Addr = 0;                                                     //      
    TestMEM.block.Size = (64*1024);                                             //      
    TestMEM.param.radix = RADIX_32;                                             //       
    TestMEM.param.type = TEST_COUNTER;                                          //  "-" 
    MEM_SetChip(MEM_SRAM);                                                      //    SRAM
    uint8_t Page = 10;                                                          //                                                  
    MEM_SetPage(Page);                                                          //    10
    PRINT("  MEM_SRAM: -");
    PRINT(" : %d",Page);
    PRINT("  : %d",TestMEM.block.Addr);
    PRINT("  : %d",TestMEM.block.Size);
    PRINT("   : %d",TestMEM.param.radix*8);  
    DBG_TX_Flush();                                                             //     UART 
    if(!MEMTEST_generic(&TestMEM))                                              //   
    {
        PRINT("   !"); 
    } 
    else 
    {
        PRINT("  !");
    }
    PRINT("- : %d", TestMEM.errors.Errors);
    DBG_TX_Flush();                                                             //     UART
    memset((uint8_t*)&TestMEM.errors,0,sizeof(TEST_ERRORS));                    //   TestMEM
    
    //  TestMEM      
    TestMEM.block.Addr = 0;
    TestMEM.block.Size = (1024);
    TestMEM.param.radix = RADIX_32;
    TestMEM.param.type = TEST_GALOPPING;                                        //  "-" TEST_GALOPPING
    MEM_SetChip(MEM_MRAM);                                                      //    SRAM
    Page = 3;                                                                   //    3
    MEM_SetPage(Page);      

    PRINT(" : %d",Page);
    PRINT("  : %d",TestMEM.block.Addr);
    PRINT("  : %d",TestMEM.block.Size);
    PRINT("   : %d",TestMEM.param.radix*8);  
    DBG_TX_Flush();
    if(!MEMTEST_generic(&TestMEM))                                              //   
    {                                             
        PRINT("   !");
    }
    else 
    {
        PRINT("  !");
    }  
    PRINT("- : %d", TestMEM.errors.Errors); 
    DBG_TX_Flush();
    memset((uint8_t*)&TestMEM.errors,0,sizeof(TEST_ERRORS));                    //   TestMEM
    
    //  TestMEM     
    TestMEM.block.Addr = 0;
    TestMEM.block.Size = (64*1024);
    TestMEM.param.radix = RADIX_32;
    TestMEM.param.type = TEST_MARCHAL;                                          //  " " 
    MEM_SetChip(MEM_MRAM);                                                      //    SRAM
    Page =  6;
    MEM_SetPage(Page);                                                          //    6  
    PRINT("  SRAM:  ");
    PRINT(" : %d",Page);
    PRINT("  : %d",TestMEM.block.Addr);
    PRINT("  : %d",TestMEM.block.Size); 
    PRINT("   : %d",TestMEM.param.radix*8);
    DBG_TX_Flush();
    if(!MEMTEST_generic(&TestMEM))                                              //   
    {
        PRINT("   !");
    }
    else 
    {  
        PRINT("  !");
    }
    PRINT("- : %d", TestMEM.errors.Errors);   
    DBG_TX_Flush();    
    
}



