/*!\file
 * \brief    ,           Can.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#ifndef CAN_TEST_H_
#define CAN_TEST_H_
#include "system.h"
#include "gpio.h"  
#include "debug_uart.h"
#include "can.h"

#define BasicCAN_0 ((CAN_T *) 0xA01B0000)
#define BasicCAN_1 ((CAN_T *) 0xA01C0000)
#define PeliCAN_0 ((CAN_EXTANDED_T *) 0xA01B0000)
#define PeliCAN_1 ((CAN_EXTANDED_T *) 0xA01C0000)

// 
#define CAN_0_IRQ_NUM 24
#define CAN_1_IRQ_NUM 25



void Init_ports_CAN(unsigned int mode);
void CAN_to_USB_Test();

#endif //CAN_TEST_H_