
/*!\file
 * \brief         .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "mem_test.h"
#include "flash_test.h"
uint8_t* reg = (uint8_t*)0x20004;                                               //    
uint32_t err_numbers[31];
uint32_t a;
uint32_t val=0;
void Memtest_Addr( unsigned int mask)
{
    unsigned int addr;
    unsigned int errors = 0;   
    volatile  uint32_t i=0;
    *reg = mask;                                                                //  
    for (addr =0x10000; addr < 0x20000; addr += 4)
    {
                
        val=0xffffffff-i+mask*0x11111111;
        FLASH_Write(addr, (uint8_t*)&val, 4);
        //for(int l =0;l<10000;l++);
        //FLASH_BypassWrite(addr+2,&(((uint8_t*)&val)[2]), 2);      
        i+=1;  

    }                                                                           //  Pagei
                
    uint32_t j=0;
    for (addr = 0x10000; addr < 0x20000; addr += 4)                             //  
    {
          a = *(uint32_t*)addr;
          val=0xffffffff-j+mask*0x11111111;

          if (a!=val)
          {
            PRINT("Address (0x%x) read: 0x%x wr:0x%x",addr,*(unsigned int*)addr,val); 
              errors++;
          }
          j+=1;
    
    }         
    if (errors>0)
    {
          err_numbers[mask] = errors;
    }
    else
    {
          err_numbers[mask] = 0;
    }            
}
int TestPage()
{
        PRINT(" counter");
        DBG_TX_Flush();                                                         //     UART
        uint32_t cnt_error=0;
  for (int i=0;i<=15;i++)
  {
        PRINT("  %d",i);
        
        Memtest_Addr(i);                                                        //      
  }
  
  
  for (int  i=0;i<=15;i++)
  {
    cnt_error+=err_numbers[i];
  }

  return cnt_error;
}



