/*!\file
 * \brief    ,            FPU.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "fpu_test.h"

/**
 * \brief  FPU
 *
 *     FPU
 *
 *      :
 *                    -   FPU
 *                    -     
 *                    -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_fpu_ram -    
 *                      - periph_fpu_ext -    
 */   
void main()
{
 
    SystemInit();                                                               //   
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
 
    FPU_Test();                                                                 //  FPU
    
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}