/*!\file
 * \brief            .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */
#include "timer_test.h"
/**
 * \brief  Timer
 *
 *      .
 *      :
 *                    -   
 *                    -     
 *                    -    
 *                    -   
 *                     10 , 
 *                   -      
 *                
 *                    -  
 *                    -  
 *                    -       -   !
 *                  
 *      ,    .
 *          Workspace: 
 *                      - periph_timer_ram -    
 *                      - periph_timer_ext -     
 */
int main()
{
    SystemInit2();                                                               //  
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    TIMER_Test();                                                               //  
      
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}
