/*!\file
 * \brief    ,          I2C.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */



#ifndef I2C_TEST_H_
#define I2C_TEST_H_

#include "system.h"
#include "dma.h"
#include "debug_uart.h"
#include "uart.h"
#include "gpio.h"   
#include "i2c.h"
#include "types.h"
#include "chip_5023BC016.h"


#define CLK80MHZ_BAUDRATE_100KHZ 0x9F                                           
#define CLK80MHZ_BAUDRATE_400KHZ 0x27

void Test_I2C();


#endif //I2C_TEST_H_
