/*!\file
 * \brief    ,          I2C.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "i2c_test.h"


const unsigned int sys_freq = 80000000;                                     
char dbg_buffer[256];   

/**
 * \brief  I2C
 *
 *     I2C
 *
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_i2c_ram -    
 *                      - periph_i2c_ext -    
 */   
void main()
{
 
    SystemInit();                                                               //   
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    I2C_Init(I2C,CLK80MHZ_BAUDRATE_400KHZ);
    Test_I2C();                                                                 
    
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}